Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4TritonEvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4TritonEvaporationProbability.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4TritonEvaporationProbability.cc	(revision 1315)
@@ -219,5 +219,8 @@
   ecut = (ecut-a) / (p+p);
   ecut2 = ecut;
-  if (cut < 0.) ecut2 = ecut - 2.;
+//JMQ 290310 for avoiding unphysical increase below minimum (at ecut)
+//ecut<0 means that there is no cut with energy axis, i.e. xs is set to 0 bellow minimum
+//  if (cut < 0.) ecut2 = ecut - 2.;
+  if (cut < 0.) ecut2 = ecut;
   elab = K * FragmentA / ResidualA;
   sig = 0.;
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4VEvaporation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4VEvaporation.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4VEvaporation.cc	(revision 1315)
@@ -24,7 +24,6 @@
 // ********************************************************************
 //
-//
-// $Id: G4VEvaporation.cc,v 1.5 2006/06/29 20:10:49 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4VEvaporation.cc,v 1.7 2010/04/27 14:00:40 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -32,32 +31,14 @@
 //
 
+#include "G4VEvaporation.hh"
 
-#include "G4VEvaporation.hh"
-#include "G4HadronicException.hh"
+G4VEvaporation::G4VEvaporation() 
+{}
 
-G4VEvaporation::G4VEvaporation(const G4VEvaporation &)
-{
- throw G4HadronicException(__FILE__, __LINE__, "G4VEvaporation::copy_constructor meant to not be accessable");
-}
+G4VEvaporation::~G4VEvaporation() 
+{}
 
-
-
-
-const G4VEvaporation & G4VEvaporation::operator=(const G4VEvaporation &)
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4VEvaporation::operator= meant to not be accessable");
-  return *this;
-}
-
-
-G4bool G4VEvaporation::operator==(const G4VEvaporation &) const
-{
-  return false;
-}
-
-G4bool G4VEvaporation::operator!=(const G4VEvaporation &) const
-{
-  return true;
-}
+void G4VEvaporation::Initialise()
+{}
 
 
Index: trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/include/G4FermiPhaseSpaceDecay.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/include/G4FermiPhaseSpaceDecay.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/include/G4FermiPhaseSpaceDecay.hh	(revision 1315)
@@ -33,4 +33,6 @@
 #include "G4LorentzVector.hh"
 #include "G4ParticleMomentum.hh"
+#include "Randomize.hh"
+#include "G4Pow.hh"
 #include <CLHEP/Random/RandGamma.h>
 
@@ -41,6 +43,7 @@
 {
 public:
-  inline G4FermiPhaseSpaceDecay();
-  inline ~G4FermiPhaseSpaceDecay();
+
+  G4FermiPhaseSpaceDecay();
+  ~G4FermiPhaseSpaceDecay();
   
   inline std::vector<G4LorentzVector*> * 
@@ -48,8 +51,9 @@
 
 private:
-  inline G4FermiPhaseSpaceDecay(const G4FermiPhaseSpaceDecay&);
-  inline const G4FermiPhaseSpaceDecay & operator=(const G4FermiPhaseSpaceDecay &); 
-  inline G4bool operator==(const G4FermiPhaseSpaceDecay&);
-  inline G4bool operator!=(const G4FermiPhaseSpaceDecay&);
+
+  G4FermiPhaseSpaceDecay(const G4FermiPhaseSpaceDecay&);
+  const G4FermiPhaseSpaceDecay & operator=(const G4FermiPhaseSpaceDecay &); 
+  G4bool operator==(const G4FermiPhaseSpaceDecay&);
+  G4bool operator!=(const G4FermiPhaseSpaceDecay&);
 
   inline G4double PtwoBody(G4double E, G4double P1, G4double P2) const;
@@ -69,5 +73,47 @@
 };
 
-#include "G4FermiPhaseSpaceDecay.icc"
+inline G4double 
+G4FermiPhaseSpaceDecay::PtwoBody(G4double E, G4double P1, G4double P2) const
+{
+  G4double res = -1.0;
+  G4double P = (E+P1+P2)*(E+P1-P2)*(E-P1+P2)*(E-P1-P2)/(4.0*E*E);
+  if (P>0.0) { res = std::sqrt(P); }
+  return res;
+}
+
+inline std::vector<G4LorentzVector*> * G4FermiPhaseSpaceDecay::
+Decay(const G4double parent_mass, const std::vector<G4double>& fragment_masses) const
+{
+  return KopylovNBodyDecay(parent_mass,fragment_masses);
+}
+
+inline G4double 
+G4FermiPhaseSpaceDecay::BetaKopylov(const G4int K) const
+{
+  //JMQ 250410 old algorithm has been commented
+  // Notice that alpha > beta always
+  // const G4double beta = 1.5;
+  // G4double alpha = 1.5*(K-1);
+  // G4double Y1 = CLHEP::RandGamma::shoot(alpha,1);
+  // G4double Y2 = CLHEP::RandGamma::shoot(beta,1);
+  
+  // return Y1/(Y1+Y2);
+
+  G4Pow* g4pow = G4Pow::GetInstance();
+  G4int N = 3*K - 5;
+  G4double xN = G4double(N);
+  G4double F;
+  //G4double Fmax = std::pow((3.*K-5.)/(3.*K-4.),(3.*K-5.)/2.)*std::sqrt(1-((3.*K-5.)/(3.*K-4.))); 
+  // VI variant
+  G4double Fmax = std::sqrt(g4pow->powZ(N, xN/(xN + 1))/(xN + 1)); 
+  G4double chi;
+  do 
+    {
+      chi = G4UniformRand();
+      F = std::sqrt(g4pow->powZ(N, chi)*(1-chi));      
+    } while ( Fmax*G4UniformRand() > F);  
+  return chi;
+
+}
 
 #endif
Index: trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/src/G4FermiConfiguration.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/src/G4FermiConfiguration.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/src/G4FermiConfiguration.cc	(revision 1315)
@@ -25,12 +25,12 @@
 //
 //
-// $Id: G4FermiConfiguration.cc,v 1.12 2009/12/16 17:51:09 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4FermiConfiguration.cc,v 1.13 2010/04/26 11:14:28 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
 // by V. Lara (Nov 1998)
 //
-// J.M.Quesada (12 October 2009) new implementation of Gamma function in configuration weight 
-
+// J. M. Quesada (12 October 2009) new implementation of Gamma function in configuration weight 
+// J. M. Quesada (09 March 2010) Kappa is set to 6.
 
 #include "G4FermiConfiguration.hh"
@@ -40,5 +40,8 @@
 // Kappa = V/V_0 it is used in calculation of Coulomb energy
 // Kappa is adimensional
-const G4double G4FermiConfiguration::Kappa = 1.0;
+// JMQ 090310 according to model developer (A. Botvina) no theoretical constraint for kappa below 10
+// kappa values  larger than 1 seem to provide better results. 6 is a good choice  
+// const G4double G4FermiConfiguration::Kappa = 1.0;
+const G4double G4FermiConfiguration::Kappa = 6.0;
 
 // r0 is the nuclear radius
Index: trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/src/G4FermiFragmentsPool.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/src/G4FermiFragmentsPool.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/src/G4FermiFragmentsPool.cc	(revision 1315)
@@ -28,10 +28,12 @@
 // by V. Lara
 //
-// J.M.Quesada (JMQ) July 2009, bug fixed in excitation energies: 
+// J.M.Quesada,  July 2009, bug fixed in excitation energies: 
 // ALL of them are in MeV instead of keV (as they were expressed previously)
 // source:  http://www.nndc.bnl.gov/chart
 // Unknown excitation energies in He5  and Li5 have been suppressed
 // Long lived levels (half-lives of the order ps-fs have been included)   
-
+//
+// J. M. Quesada,  April 2010: excitation energies according to tabulated values 
+// in PhotonEvaporatoion2.0. Fake photons eliminated. 
 
 #include "G4FermiFragmentsPool.hh"
